/* 
 * File:   text.h
 * Author: Pavel
 *
 * Created on 15. ervna 2018, 18:38
 */


#ifndef TEXT_H
#define	TEXT_H


//                                    IODIR       IPOL     GPINTE   DEFVAL   INTCON   IOCON       GPPU        INTF  INTC    GPIO      OLAT
//                           adr   r  0     1     2  3     4  5     6  7     8  9     A     B     C     D     E  F  10 11   12    13  14   15 
static const char Init1[] = {0x42, 0, 0xFF, 0xFF, 0, 0, 0, 0, 0, 0, 0, 0, 0x4A, 0x4A, 0x00, 0x00, 0, 0, 0, 0, 0, 0, 0x00, 0};
static const char Init2[] = {0x44, 0, 0x00, 0x1F, 0, 0x1F, 0, 0x00, 0, 0x00, 0, 0x00, 0x4C, 0x4C, 0x00, 0x1F, 0, 0, 0, 0, 0xFF, 0, 0xFF, 0};
static const char Init3[] = {0x46, 0, 0x00, 0x1F, 0, 0x1F, 0, 0x00, 0, 0x00, 0, 0x00, 0x4C, 0x4C, 0x00, 0x1F, 0, 0, 0, 0, 0xFF, 0, 0xFF, 0};

const char * const BaudText[] = {
    "300", "1200", "2400", "4800", "9600", "19200", "38400", "57600", "115200"
};
static const char Baud[] = {
    0x54, 0xD0, 0x14, 0x34, 0x0A, 0x1A, 0x05, 0x0D, 0x82, 0x06, 0x40, 0x03, 0x0A, 0x01, 0x16, 0x01, 0x8A, 0x00
};
//   300,       1200,       2400,       4800,       9600,       19200,      38400,      57600,      115200
//  53332       13332       6666        3333        1666        832         416         278         138

const char * const HWCText1[] = {//6
    "Off  ", " -  - ", "RTS - ", " - CTS", "RTSCTS", "CAN  "
};

const char * const HWCText2[] = {//6
    "Off  ", "USB  ", " -  - ", "RTS - ", " - CTS", "RTSCTS"
};

const char * const PWText[] = {//8
    " 1us  ", " 10us ", " 100us", " 1ms  ", " 10ms ", " 100ms", " 1s  ", " 10s  "
};
static const unsigned int tconst[] = {
    0x01, 0x01, 0x01, 0x01, 10, 100, 1000, 10000
};

const char * const FreqText[] = {//8
    " 1Hz  ", " 10Hz ", " 100Hz", " 1kHz  ", " 10kHz ", " 20kHz", " 1s  ", " 10s  "
};

static const unsigned int freqcTab[] = {
    4999, 999, 499, 99, 49, 19, 9, 4, 1, 0
}; // 0.1Hz  0.5Hz   1Hz  5Hz   10Hz  25Hz  50Hz 100Hz  250Hz    500Hz
const char * const FreqCText[] = {//8
    "0.1Hz", "0.5Hz", " 1Hz  ", " 5Hz  ", " 10Hz ", " 25Hz ", " 50Hz ", "100Hz ", "250Hz ", "500Hz "
};
const char * const SPIText[] = {//4
    "Off  ", "TC77 ","OUT  ", "IN  "
};
const char * const AUXText[] = {//4
    "Off  ", "IN-OUT", "KBD  ", "ENC  "
};
const char * const CHNText[] = {//6
    "Off  ", "OUTA ", "OUTB ", "OUTC"
};

const char * const SRText[] = {//6
    "Off  ", "RoS ", "SoE", "S&R"
};


static const char text2[][8] = {
    "LOGIC", "TESTER"
};
static const char menutext[][8][12] = {
    {
        "Run reim", //0
        "Hradlovan", //1
        "Tstavov", //2
        "Nastaven", //3
        "Funkce", //4
        "Pulsy", //5
        "Systm", //6
        "IC test"  //7
    }, 

    {
        "Zznam",
        "Vpis"
}

};

static const char text3[][8][4] = {
    { "PWA","FQA","CTA","FQC", "PWB","FQB", "CTB","CHN"},
    { "Bd1","HC1", "S&R", "SPI", "Bd2","HC2",  "LED", "AUX"},
    { "IC", "Vdd", "PUP", "OUT", "ICV","NAP", " ", " "}    
};

static const char text4[][16] = {
    " Vypni", //0
    "Ulo a vypni", //1
    "ANO", //2
    "NE",//3
    "5V", //4
    "3V", //5
    "3.3V", //6
    "Teplota: ", //7
    "RAM test: ", //8   
    "SPI OUT: ",   //9 
    "SPI IN: ",    //10
    "Freq: ", //11
    "Count: ", //12
    "RAM OK",  //13
    "Hz"       //14 
            

};
static const char tlac[][10] = {

    "89\x1A\x1B\x1C\x1D\x1E\x1F", //0
    "01234567", //1
    "RHTNFPSI", //2
    "NSCKBRZA", //3
    "abcdefgh", //4   
    "rtabtric", //5
    "Vzmxnops", //6    
    "aA   OBb", //7 
    " A \xCB\xCA B ", //8
    " A    B ", //9
    "S \xCB\xEB\xEA\xCA R", //10
    "  \xCB\xEB\xEA\xCA  ", //11        
    "STFC   R" //12

};


#endif	/* XC_HEADER_TEMPLATE_H */

