/*
 * File:   utils.c
 * Author: Pavel
 *
 * Created on 15. ervna 2018, 18:38
 */

#include <xc.h>
#include "fnt85.h"
#include "ltest2.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/*
struct CONT {
    int xMin;
    int xMax;
    int yMin;
    int yMax;
    char col;
};
struct CONT cont;
 */
struct ATR atr[2];
struct BUTS buts;
char gbuf[1024]; // + 256];
char bld = 0;
char win = 0;

char inpt2, inpt3;
char bptr[24];
char pstr[30];
char nstr[30];
char numb[30] = "123456789\x0B\x0C\x0D\x0E\x0F\x10\x11\x12\x13\x14"; //123456789\x0A\x0B\x0C\x0D\x0E\x0F\x10\x11\x12\x13\x14";
char ino[24] = "00000000000000";
char nmb, bits;
char btn[24];
char istr[10];
//struct SD sdt;


void Sdelay(unsigned int usec) //po 62.5ns pi 16 MHz -
{
    while (usec--);
}

void Delay(int ms) { //ms
    while (ms) {
        _delay(16000);
        ms--;
    }
}//

void Udelay(char dl) {

    while (dl) {
        _delay(160); //10us 16MHz fclock
        dl--;
    }
}//

void EWrite(char adr, char val) {
    char gint = (char) GIE;
    EEADRH = 0;
    EEADR = adr;
    EEDATA = val;
    EEPGD = 0;
    CFGS = 0;
    WREN = 1;
    GIE = 0;
    EECON2 = 0x55;
    EECON2 = 0xAA;
    WR = 1;
    while (WR);
    GIE = gint;
    WREN = 0;
}

char ERead(char adr) {
    char data;
    EEADRH = 0;
    EEADR = adr;
    EEPGD = 0;
    CFGS = 0;
    RD = 1;
    data = EEDATA;
    return data;
}//

void SPIOpen() {
    SSPSTAT &= 0x3F; // power on state
    SSPCON1 = 0x21; //2 = fosc/64 1 = fosc/16
    CKE = 1; //  1 = transmit 1->0   BF = buffer full
    CKP = 0; // clock polar 0 = idle
    //BOEN = 1; //ignoruje BF p?ete?en
    // PIE1bits.SSPIE = 1;
    SSPCON1bits.SSPEN = 1;
}//

void SPIInit(char *val) {
    char dm; //pot 0 = slev; pot 1 = mod
    CS0 = 0;
    for (char i = 16; i > 0; i--) {
        SSPBUF = *val;
        while (!SSPIF);
        dm = SSPBUF;
        SSPIF = 0;
        val++;
    }
    CS0 = 1;
}

char SPIRead(char adr, char reg) {
    char dm = 0;
    CS0 = 0;
    SSPBUF = (char) (0x41 | (adr * 2));
    while (!SSPIF);
    dm = SSPBUF;
    SSPIF = 0;
    SSPBUF = reg;
    while (!SSPIF);
    SSPIF = 0;
    SSPBUF = 0; //dummy
    while (!SSPIF);
    SSPIF = 0;
    dm = SSPBUF;
    SSPIF = 0;
    CS0 = 1;
    return dm;
}

unsigned int SPIRead2(char adr, char reg) {
    unsigned int dm = 0;
    CS0 = 0;
    SSPBUF = (char) (0x41 | (adr * 2));
    while (!SSPIF);
    dm = SSPBUF;
    SSPIF = 0;
    SSPBUF = reg;
    while (!SSPIF);
    SSPIF = 0;
    SSPBUF = 0; //dummy
    while (!SSPIF);
    SSPIF = 0;
    dm = SSPBUF;
    SSPIF = 0;
    SSPBUF = 0; //dummy
    while (!SSPIF);
    SSPIF = 0;
    *((char *) &dm + 1) = SSPBUF;
    SSPIF = 0;
    CS0 = 1;
    return dm;
}

void SPISend1(char adr, char reg, char val) {
    char dm; //pot 0 = slev; pot 1 = mod
    CS0 = 0;
    SSPBUF = (char) (0x40 | (adr * 2));
    while (!SSPIF);
    dm = SSPBUF;
    SSPIF = 0;
    SSPBUF = reg;
    while (!SSPIF);
    dm = SSPBUF;
    SSPIF = 0;
    SSPBUF = val;
    while (!SSPIF);
    dm = SSPBUF;
    SSPIF = 0;
    CS0 = 1;
}

void SPISend2(char adr, char reg, unsigned int val) {
    char dm; //pot 0 = slev; pot 1 = mod
    CS0 = 0;
    SSPBUF = (char) (0x40 | (adr * 2));
    while (!SSPIF);
    dm = SSPBUF;
    SSPIF = 0;
    SSPBUF = reg;
    while (!SSPIF);
    dm = SSPBUF;
    SSPIF = 0;
    SSPBUF = val;
    while (!SSPIF);
    dm = SSPBUF;
    SSPIF = 0;

    SSPBUF = *((char *) &val + 1);
    while (!SSPIF);
    dm = SSPBUF;
    SSPIF = 0;

    CS0 = 1;
}

struct BUTS ReadButs() {
    buts.b8 = 0;
    buts.b2 = 0;
    inpt2 = SPIRead(2, 0x13);
    inpt3 = SPIRead(3, 0x13);
    if (inpt2 & 0x10) buts.b2 |= 1;
    if (inpt3 & 0x10) buts.b2 |= 2;
    buts.b8 = (char) (inpt2 & 0x0F);
    buts.b8 |= (char) ((inpt3 << 4)&0xF0);
    return buts;
}

void LEDS(char tgreen, char tred, char tME) {
    unsigned int led1;
    unsigned int led2;
    led1 = ((tgreen & 0x0F) | ((tred & 0x0F) << 4))^0xFF;
    led2 = (((tgreen & 0xF0) >> 4) | (tred & 0xF0))^0xFF;
    *((char *) &led1 + 1) = ((tME & 0x0F) << 4)^0x60;
    *((char *) &led2 + 1) = (tME & 0xF0)^0x60;

    SPISend2(2, 0x14, led1);
    SPISend2(3, 0x14, led2);
}//

void WriteLCD(char dat, char cd) //if cd=0  Transfer command, cd=1  Transfer data
{

    if (cd)
        DI = 1;
    else
        DI = 0; //RS
    Sdelay(4);

    PORTA &= 0xF0;
    PORTA |= (dat >> 4) & 0x0F;
    Sdelay(2);
    EN = 1; //80ns
    Sdelay(24); //2 us
    EN = 0; //E  80ns
    Sdelay(2);
    PORTA &= 0xF0;
    PORTA |= dat & 0x0F; //
    Sdelay(2);
    EN = 1; //80ns  E->1
    Sdelay(24); //2 us
    EN = 0; //80ns  E->0
    Sdelay(2);
}



/*
void init_1(void) //LCD init  Fonts Mode
{
    WriteLCD(0x20, 0); //Extended Function Set :8BIT,RE=0: basic instruction set, G=0 :graphic display OFF
    Delay(1);
    WriteLCD(0x20, 0); //Extended Function Set :8BIT,RE=0: basic instruction set, G=0 :graphic display OFF
    Delay(1);
    WriteLCD(0x20, 0); //Function Set
    Delay(3);
    WriteLCD(0x08, 0); //Display on Control
    Delay(1);
    WriteLCD(0x10, 0); //Cursor Display Control
    Delay(1);
    WriteLCD(0x0C, 0); //Display Control,D=1,display on
    Delay(1);
    WriteLCD(0x01, 0); //Display Clear
    Delay(1);
    WriteLCD(0x06, 0); //Entry Mode Set
    Delay(1);
}//
 */
void init_2(void) //Graphic display Mode
{
    WriteLCD(0x20, 0); //Extended Function Set RE=1: extended instruction
    Delay(3);
    WriteLCD(0x20, 0); //Extended Function Set RE=1: extended instruction
    Delay(3);
    WriteLCD(0x20, 0); //Extended Function Set RE=1: extended instruction
    Delay(3);
  //  WriteLCD(0x08, 0); //Display on Control  ???
  //  Delay(1);
    WriteLCD(0x01, 0); //Display Clear
    Delay(15);
    WriteLCD(0x24, 0); //Extended Function Set RE=1: extended instruction
    Delay(1);
    WriteLCD(0x26, 0); //Extended Function Set:RE=1: extended instruction set
    Delay(1);
}
/*
void lcd_text(char x, char y, char *str1) {
    char i;
    static const char adr[] = {0x80, 0x90, 0x88, 0x98};
    WriteLCD((char) adr[y] + (char) x / 2, 0);
    Delay(1);
    //for(i=x; i<16; i++)
    while (*str1) {
        WriteLCD(*str1, 1);
        str1++;
    }//for
}//
 */

void GbufToLCD() {
    char i, j, dy;
    char *buf;
    buf = gbuf;
    for (dy = 0; dy < 9; dy += 8) {
        for (i = 0; i < 32; i++) //
        {
            WriteLCD((0x80 + i), 0); //SET   VERTICAL ADDRESS
            WriteLCD(0x80 + dy, 0); //SET   HORIZONTAL ADDRESS

            for (j = 0; j < 16; j++) {
                WriteLCD(*buf, 1);
                buf++;
            }
        }
    }
}//

void Pix(signed char x, signed char y, signed char inv) {
    char j = 0x80, dx;
    if ((x < 0) /*|| (x>127)*/ || (y < 0) || (y > 63))return;
    dx = x / 8;
    j >>= (x & 0x07);
    switch (inv) {
        case -1: break;
        case COL0: gbuf[y * 16 + dx] &= ~j;
            break;
        case XOR: gbuf[y * 16 + dx] ^= j;
            break;
        default: gbuf[y * 16 + dx] |= j;
            break;
    }
}

void Line(char x1, char x2, char y1, char y2, char t) {
    int y, x, dx;
    char fil = 1, inv = 1;
    inv = t & 0x60;

    if (t & DOT)fil = 2;
    t &= 0x3;
    if (x1 > x2) {
        dx = x2;
        x2 = x1;
        x1 = dx;
    };
    if (y1 > y2) {
        dx = y2;
        y2 = y1;
        y1 = dx;
    };
    x2++;
    y2++;
    if ((x2 - x1) >= (y2 - y1)) {
        for (x = 0; x < (x2 - x1); x += fil) {
            y = ((y2 - y1) * x) / (x2 - x1);
            Pix(x + x1, y + y1, inv);
            if (t > 1)Pix(x + x1, y1 + y + 1, inv);
            if (t > 2)Pix(x + x1, y1 + y - 1, inv);
        }
    } else {
        for (y = 0; y < (y2 - y1); y += fil) {
            x = ((x2 - x1) * y) / (y2 - y1);
            Pix(x + x1, y + y1, inv);
            if (t > 1)Pix(x1 + x + 1, y + y1, inv);
            if (t > 2)Pix(x1 + x - 1, y + y1, inv);
        }
    }
}//

void Bord1(char x1, char x2, char y1, char y2, char tl) { //mod: 1,2,3 síla rámečku, 4 dvojitý
    char it, di = 1, t = 0, dt = 1, corn = 0; //DOT tečkovaný, CORN seseknuté rohy,
    if (tl & DOT)dt = 2; //XOR inverzní, COL0 bílý
    if (tl & CORN)corn = 1;
    t |= (tl & (DOT | XOR | COL0));
    tl &= 0x07;

    if (tl == 4) {
        di = 2;
    }
    for (it = 0; it < tl; it += di) {
        if (corn == 0) {
            Line(x1 + it, x2 - it, y1 + it, y1 + it, t);
            Line(x1 + it, x2 - it, y2 - it, y2 - it, t);
            Line(x1 + it, x1 + it, y1 + dt + it, y2 - dt - it, t);
            Line(x2 - it, x2 - it, y1 + dt + it, y2 - dt - it, t);
        } else {
            Line(x1 + it + 2, x2 - it - 2, y1 + it, y1 + it, t);
            Pix(x1 + it + 1, y1 + it + 1, t);
            Line(x1 + it + 2, x2 - it - 2, y2 - it, y2 - it, t);
            Pix(x2 - it - 1, y1 + it + 1, t);
            Line(x1 + it, x1 + it, y1 + dt + it + 1, y2 - dt - it - 1, t);
            Pix(x1 + it + 1, y2 - it - 1, t);
            Line(x2 - it, x2 - it, y1 + dt + it + 1, y2 - dt - it - 1, t);
            Pix(x2 - it - 1, y2 - it - 1, t);
        }
    }
}//

void Bord2(char x, char dx, char y, char dy, char tl) {
    Bord1(x, x + dx - 1, y, y + dy - 1, tl);
}

void Attrib(char wi, char bld, char md, char wx, char wy, char wdx, char wdy, char sx, char sy, char re) {

    atr[wi].bold = bld;
    atr[wi].tmod = md;
    atr[wi].stpx = sx, atr[wi].stpy = sy, atr[wi].rend = re;
    atr[wi].wx1 = wx;
    atr[wi].wy1 = wy;
    atr[wi].wx2 = wx + wdx - 1;
    atr[wi].wy2 = wy + wdy - 1;
    atr[wi].wdx = wdx;
    atr[wi].wdy = wdy;
}//

void GbufFill(char ch) {
    memset((char *) gbuf, ch, sizeof (gbuf));
}//

char WinKamChr(char ck) {
    unsigned char ch;
    ch = ck;
    if (ck > 127) {
        ch = WinKam[ck - 128] + 128;
    }
    return ch;
}//

void Ch8(char x, char y, char *ch, char mod) {
    char i, dx, *ptr, *spt, *gptr, *gend;
    unsigned int sh = 0, so;
    dx = x / 8;
    gend = &gbuf[1023];
    gptr = &gbuf[y * 16 + dx ];
    ptr = (char *) &sh;
    spt = (char *) &so;
    for (i = 0; i < 8; i++) {
        sh = ch[i];
        sh <<= (8 + dx * 8 - x);

        if (atr[win].bold || mod & 1) {
            so = sh;
            sh >>= 1;
            switch (mod & 0xFE) {
                case COL0: *(gptr + 1) &= ~(sh | so);
                    *gptr &= ~*(ptr + 1) | *(spt + 1);
                    break;
                case XOR: *(gptr + 1) ^= (sh | so);
                    *gptr ^= *(ptr + 1) | *(spt + 1);
                    break;
                case OVR:*(gptr + 1) = (sh | so);
                    *gptr = *(ptr + 1) | *(spt + 1);
                    break;
                default:*(gptr + 1) |= (sh | so);
                    *gptr |= *(ptr + 1) | *(spt + 1);
                    break;
            }

        } else {
            switch (mod & 0xFE) {
                case COL0: *(gptr + 1) &= ~sh;
                    *gptr &= ~*(ptr + 1);
                    break;
                case XOR:*(gptr + 1) ^= sh;
                    *gptr ^= *(ptr + 1);
                    break;
                case OVR:*(gptr + 1) = sh;
                    *gptr = *(ptr + 1);
                    break;
                default: *(gptr + 1) |= sh;
                    *gptr |= *(ptr + 1);
                    break;
            }

        }
        gptr += 16;
        if (gptr > gend) return;
    }
}//

void Ch16(char x, char y, char *ch, char mod) {
    char i, j, dx, *gptr, *gend, *ptr;
    unsigned int so, sch;
    unsigned long int sh = 0;
    dx = x / 8;
    gend = &gbuf[1023];
    gptr = &gbuf[y * 16 + dx ];
    ptr = (char *) &sh;

    for (i = 0; i < 16; i++) {
        sh = 0;
        sch = ch[i / 2];
        for (j = 0; j < 8; j++) {
            if (sch & 0x80) {
                sh <<= 1;
                sh++;
                sh <<= 1;
                sh++;
            } else {
                sh <<= 2;
            }
            sch <<= 1;
        }
        sh <<= (8 + dx * 8 - x);

        switch (mod) {
            case COL0: *(gptr + 2) &= ~ *(ptr);
                *(gptr + 1) &= ~ *(ptr + 1);
                *(gptr) &= ~ *(ptr + 2);
                break;
            case XOR: *(gptr + 2) ^= *(ptr);
                *(gptr + 1) ^= *(ptr + 1);
                *(gptr) ^= *(ptr + 2);
                break;
            case OVR: *(gptr + 2) = *(ptr);
                *(gptr + 1) = *(ptr + 1);
                *(gptr) = *(ptr + 2);
                break;
            default: *(gptr + 2) |= *(ptr);
                *(gptr + 1) |= *(ptr + 1);
                *(gptr) |= *(ptr + 2);
                break;
        }


        //   *(gptr+2) |= *(ptr+1); *(gptr+1)|=*(ptr+2); *(gptr)|= *(ptr+3);
        gptr += 16;
        if (gptr > gend) return;
    }
}//

void Char16(char x, char y, char ch, char mod) {
    Ch16(x, y, (char *) fnt3[WinKamChr(ch)], mod);
}//

void Char8(char x, char y, char ch, char mod) {
    Ch8(x, y, (char *) fnt3[WinKamChr(ch)], mod);
}//

void Char8d(char x, char y, char ch, char mod) {
    Ch8(x, y, (char *) fnt3[ch], mod);
}//

void Text(char x, char y, char stpx, char stpy, char *str, char mod) {
    char ti, ch, bg = 0;
    if (mod & 0x80)bg = 1;

    if (x == NX)x = atr[win].nx;
    if (y == NY)y = atr[win].ny;

    x += atr[win].wx1;
    y += atr[win].wy1;

    atr[win].cx = x;
    atr[win].cy = y;
    ti = x;
    while (*str) {
        if (*str == '\n') {
            str++;
            ti = x;
            y += stpy; //newline
        }
        ch = *str;
        if (ch) {
            if (bg == 0)Ch8(ti, y, (char *) fnt3[WinKamChr(ch)], mod);
            else Ch16(ti, y, (char *) fnt3[WinKamChr(ch)], mod);
            str++;
            ti += stpx;
        }
        if (ti > (atr[win].rend - stpx + atr[win].wx1)) {
            ti = x;
            y += stpy;
        }
    }
    atr[win].nx = ti - atr[win].wx1;
    atr[win].ny = y - atr[win].wy1;
}//

void Textd(char x, char y, char stpx, char stpy, char *str, char mod) {
    char ti, ch, bg = 0;
    if (mod & 0x80)bg = 1;

    if (x == NX)x = atr[win].nx;
    if (y == NY)y = atr[win].ny;

    x += atr[win].wx1;
    y += atr[win].wy1;

    atr[win].cx = x;
    atr[win].cy = y;
    ti = x;
    while (*str) {
        if (*str == '\n') {
            str++;
            ti = x;
            y += stpy; //newline
        }
        ch = *str;
        if (ch) {
            if (bg == 0)Ch8(ti, y, (char *) fnt3[ch], mod);
            else Ch16(ti, y, (char *) fnt3[ch], mod);
            str++;
            ti += stpx;
        }
        if (ti > (atr[win].rend - stpx + atr[win].wx1)) {
            ti = x;
            y += stpy;
        }
    }
    atr[win].nx = ti - atr[win].wx1;
    atr[win].ny = y - atr[win].wy1;
}//

void TextA(char x, char y, char *str) {
    Text(x, y, atr[win].stpx, atr[win].stpy, str, atr[win].tmod);
}//

void TextAd(char x, char y, char *str) {
    Textd(x, y, atr[win].stpx, atr[win].stpy, str, atr[win].tmod);
}//

void Rect(char x1, char x2, char y1, char y2, char tmod) {
    char y, dy = 1;
    tmod |= 1;
    if (tmod & DOT)dy = 2;
    if (tmod & CORN) {
        for (y = y1; y <= y2; y += dy) {
            if (y == y1 || y == y2)
                Line(x1 + 2, x2 - 2, y, y, tmod);
            else if (y == y1 + 1 || y == y2 - 1)
                Line(x1 + 1, x2 - 1, y, y, tmod);
            else Line(x1, x2, y, y, tmod);
        }
    } else
        for (y = y1; y <= y2; y += dy)
            Line(x1, x2, y, y, tmod);
}//

void Rect2(char x, char dx, char y, char dy, char tmod) {

    Rect(x, x + dx - 1, y, y + dy - 1, tmod);
}



void Dil(char mod, unsigned int inp, char *icn, unsigned int flags) {
    static char len, stp = 8, x, xi, y = 16, *ps, unad = 0, un = 3,  pnmb = 0;
    static unsigned int ICinp, bit16, bitd, ICdir, ICout, ICpullup;
    char *p1, *p2, *p3, *p4, *pn;
    if (mod == 0) {
        len=strlen(icn);
        xi = *(icn + len + 1);
        ps = GetICPins(xi);
        pn = (icn + len + 3);
        ICdir = 0xFFFF; //vechno vstupy
        ICout = 0;
        ICinp = 0;
        if(flags & PULE)ICpullup = 0xFFFF; else ICpullup = 0;
        nmb = ((strlen(ps)) / 2);
        switch (nmb) {
            case 4: bitd = 0x20;
            unad = 5;   
                break;
            case 7: bitd = 4;  //6 8   5  0x10 
            unad = 2;
                break;
            case 8: bitd = 2;
            unad = 1;
                break;
            case 9: bitd = 1;
            unad = 0;
                break;
        }
        len = nmb * stp + 6;
        x = 64 - len / 2;
        p1 = numb + nmb * 2 - 1;
        p2 = nstr;
        p3 = ps + nmb * 2 - 1;
        p4 = pstr;
        for (char i = 0; i < nmb; i++) {
            *p2 = *p1;
            p2++;
            p1--;
            *p4 = *p3;
            p4++;
            p3--;
        }
        *p2 = 0x0A;
        p2++;
        *p4 = 0x0A;
        p4++;
        p1 = numb;
        p3 = ps;
        for (char i = 0; i < nmb; i++) {
            *p2 = *p1;
            p2++;
            p1++;
            *p4 = *p3;
            p4++;
            p3++;
        }
        *p2 = 0;
        *p4 = 0;
        p2 = btn;
        p4 = bptr;
        bit16 = bitd; //pro DIL 14 je 4
        for (char i = 0; i < nmb * 2; i++) {
            if (ps[i] == 0xD0 || ps[i]== 0xD5 /*|| (ps[i] == 0xD3 && flags & VDDIC)*/) {  //D5 clock
                *p2 = numb[i];
                p2++;
                *p4 = i;
                p4++;
                if(flags & OUTE ||(ps[i]== 0xD3 && flags & VDDIC))
                ICdir &= ~bit16; //ozna vstupy
                bit16 <<= 1;
            }//numb vynechv nulu
            else if (ps[i] == 0xD1 || ps[i] == 0xD4 || ps[i] == 0xD6 ) {  //D1 vstup IC,  D4 je nc
                ICdir |= bit16;                                           //D6 je O.C.
                bit16 <<= 1;
            }//ostatn jako vstupy

           // else if (ps[i] == 0xD2)ino[i] = '-';
         // else if (ps[i] == 0xD3)ino[i] = '+';
        }
        /*
        bits = 1;
            for(char i=0; i<strlen(btn); i++){
                if(inp & bits)ino[bptr[i]]='1'; else ino[bptr[i]]='0';
                bits<<=1;
            }*/
        *p2 = 0;
        *p4 = 0;
        Bord2(x, len, y, 21, COL1 | 1);
        Char8(x, y + 7, 'D', COL1);
        VDD(114,4);
        Textd(x + 5, y + 2, stp, 10, nstr, COL1); //sla pin
        Textd(x + 5, y - 6, stp, 26, pstr, COL1); // obrzky pin
        strcpy(istr,icn);
        xi = x + len + 1;
        if(strlen(istr)>4){

            Text(xi, y + 7, 6, 10, istr + 2, COL1);
            istr[2]=0;
            Text(xi , y -2, 6, 10, istr, COL1);
            TextA(xi ,y+18, pn);
        }
        else {Text(xi, y + 1, 6, 10, istr, COL1); // jmno IC
        TextA(xi,y+14,pn);
        }

        Rect2(16, 97, 54, 8, COL0);
        Textd(16, 54, 13, 10, btn, XOR ); //sla tlatek
      //  if(!(flags & OUTE)) ICdir = 0xFFFF;
        SPISend2(1, 0x0, ICdir); //smry
        SPISend2(1, 0x0C, ICpullup); //pullup zap.
    }//mod 0


    bits = 1;
    bit16 = bitd; //pro dil 14
    //vstupy z tlatek
    for (char i = 0; i < strlen(btn); i++) {
        if (inp & bits)ino[bptr[i]] = '1';
        else ino[bptr[i]] = '0';
        bits <<= 1;
    }


    bit16 = bitd; //pro dil 14
    for (char i = 0; i < nmb * 2; i++) {
        if (ps[i] == 0xD2)ino[i] = 'G';
        else if (ps[i] == 0xD3 && flags & VDDIC ){ ICout |= bit16; ICdir &= ~bit16; }

        else {
            if ((ps[i] == 0xD0 || ps[i]== 0xD5) && ino[i] == '1')ICout |= bit16;
           // else if(ps[i] == 0xD3 && flags & VDDIC )ICout |= bit16;
            else if ((ps[i] == 0xD0 || ps[i]== 0xD5)&& ino[i] == '0')ICout &= ~bit16;
            else if (ps[i] == 0xD4)ino[i] = 'x'; //NC
            bit16 <<= 1;

        }
    }//for
    SPISend2(1, 0x0, ICdir); //smry
    SPISend2(1, 0x12, ICout);

    ICinp = SPIRead2(1, 0x12);

    bit16 = bitd; //pro dil 14
    for (char i = 0; i < nmb * 2; i++) {

       if (ps[i] == 0xD2)ino[i] = 'G';
       else if (ps[i] == 0xD3){
        if(flags & VDDIC)ino[i] = 'V';
        else ino[i] = '+';
    }

    else   {
            if (ICinp & bit16) ino[i] = '1';
            else if (ps[i] == 0xD4)ino[i] = 'x'; //NC
            else ino[i] = '0';
            bit16 <<= 1;

        }
    }//for


    p1 = ino + nmb * 2 - 1;
    p2 = pstr;
    for (char i = 0; i < nmb; i++) {
        *p2 = *p1;
        p2++;
        p1--;
    }
    *p2 = 0x0A;
    p2++;


    p1 = ino;
    for (char i = 0; i < nmb; i++) {
        *p2 = *p1;
        p2++;
        p1++;
    }
    *p2 = 0;
    Rect2(x + 5, nmb*stp, y - 14, 8, COL0);
    Rect2(x + 5, nmb*stp, y + 28, 8, COL0);
    Text(x + 5, y - 14, stp, 42, pstr, COL1);

    un = pnmb = GetUn()+unad;
    
    if(un > 7)un--;
    if(un == 7){xi=0; }
    else{
    
    MpxAdr(un); //adresa mpx

    Udelay(1); //10us
        GO = 1; // start AD pevodnku -------
        while (GO);
        //
        xi = ADRESH;
        if (ADRESL & 0x0F) xi = 0;
    }
        istr[0]='U'; istr[1]=' ';
        itoa(istr+2,pnmb-1,10);
    Rect2(4,25,y+1,10,COL0);    
    Text(4,y+1,6,10,istr,COL1);
    Rect2(4,25,y+14,10,COL0);
    Text(4,y+14,6,10,Volts(xi),COL1);


}//

/*
char Reverse(char b1) {
    //reverse bit
    char bits = 1, bout = 0;
    for (char i = 0; i < 8; i++) {
        bout <<= 1;
        if (b1 & bits)bout++;
        bits <<= 1;
    }
    return bout;
}
 */

void Ramrw(char rw, unsigned long adr, char *data, char len) {

    adr |= 0x02000000L; // 2 = w
    if(rw)adr |= 0x03000000L; //3 = r

    CSEE = 0; //cs
    SSPBUF = *((char *)&adr + 3);
    while (!SSPIF);
    SSPIF = 0;
    SSPBUF = *((char *)&adr + 2);
    while (!SSPIF);
    SSPIF = 0;
    SSPBUF = *((char *)&adr + 1);
    while (!SSPIF);
    SSPIF = 0;
    SSPBUF = *((char *)&adr);
    while (!SSPIF);
    SSPIF = 0;

    if(rw){
        for(char j = 0; j<len; j++){
    SSPBUF = 0;
    while (!SSPIF);
    SSPIF = 0;
    data[j] = SSPBUF;
        }//for
    } //if rw
    else {
    for(char j = 0; j<len; j++){
    SSPBUF = data[j];
    while (!SSPIF);
    SSPIF = 0;
    }//for
    } // else
    CSEE = 1;

}

char * Volts(char vn){
    char str[16];
    static char ustr[16];
    unsigned long vu = vn*1930L;
    unsigned int vi = (vu / 10) & 0xFFFF;
    utoa(str, vi, 10); //pevod napt
    signed char sl = strlen(str);

    for (signed char i = 6; i >= 0; i--) {
        if (i == 1) {
            ustr[1] = '.';
        } else {
            if (sl < 0) ustr[i] = '0';
            else {
                ustr[i] = str[sl];
                sl--;
            }
        }
    }
ustr[4] = 0;
return ustr;
}







